#include <ESP8266WiFi.h>
#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include "Adafruit_MQTT.h"
#include "Adafruit_MQTT_Client.h"

#define WLAN_SSID       "Saakshi"
#define WLAN_PASS       "saakshi "
/************************* Adafruit.io Setup *********************************/
#define AIO_SERVER      "io.adafruit.com"
#define AIO_SERVERPORT  1883                   // use 8883 for SSL
#define AIO_USERNAME    "Saakshi_12"
#define AIO_KEY         "aio_ukzi69zb24WTQgWFRX5i7nPwfzyj"

#define LED_BUILTIN 16
#define SENSOR1  2
#define SENSOR2  3
  
volatile int flow_frequency1; // Measures flow sensor pulses
unsigned int l_hour1; // Calculated litres/hour
unsigned int fR1;
unsigned char flowsensor1 = 2; // Sensor Input
unsigned long currentTime1;
unsigned long cloopTime1;
float totalLitres1;
float price1;


volatile int flow_frequency2; // Measures flow sensor pulses
unsigned int l_hour2; // Calculated litres/hour
unsigned int fR2;
unsigned char flowsensor2 = 2; // Sensor Input
unsigned long currentTime2;
unsigned long cloopTime2;
float totalLitres2;
float price2;

void IRAM_ATTR flow () // Interrupt function
{
   flow_frequency1++;
   flow_frequency2++;
}

/************ Global State (you don't need to change this!) ******************/
// Create an ESP8266 WiFiClient class to connect to the MQTT server.
WiFiClient client;
// or... use WiFiFlientSecure for SSL
//WiFiClientSecure client;
// Setup the MQTT client class by passing in the WiFi client and MQTT server and login details.
Adafruit_MQTT_Client mqtt(&client, AIO_SERVER, AIO_SERVERPORT, AIO_USERNAME, AIO_KEY);
/****************************** Feeds ***************************************/
// Setup a feed called 'photocell' for publishing.
// Notice MQTT paths for AIO follow the form: <username>/feeds/<feedname>
Adafruit_MQTT_Publish fr1 = Adafruit_MQTT_Publish(&mqtt, AIO_USERNAME "/feeds/FlowRate");
Adafruit_MQTT_Publish v1 = Adafruit_MQTT_Publish(&mqtt, AIO_USERNAME "/feeds/Volume");
Adafruit_MQTT_Publish p1 = Adafruit_MQTT_Publish(&mqtt, AIO_USERNAME "/feeds/Price");
Adafruit_MQTT_Publish fr2 = Adafruit_MQTT_Publish(&mqtt, AIO_USERNAME "/feeds/FlowRate-2");
Adafruit_MQTT_Publish v2 = Adafruit_MQTT_Publish(&mqtt, AIO_USERNAME "/feeds/Volume-2");
Adafruit_MQTT_Publish p2 = Adafruit_MQTT_Publish(&mqtt, AIO_USERNAME "/feeds/Price-2");
/*************************** Sketch Code ************************************/
// Bug workaround for Arduino 1.6.6, it seems to need a function declaration
// for some reason (only affects ESP8266, likely an arduino-builder bug).
void MQTT_connect();
void setup()
{
  Serial.begin(115200);

  delay(10);

  Serial.println(F("Adafruit MQTT demo"));
  // Connect to WiFi access point.
  Serial.println(); Serial.println();
  Serial.print("Connecting to ");
  Serial.println(WLAN_SSID);
  WiFi.begin(WLAN_SSID, WLAN_PASS);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println();
  Serial.println("WiFi connected");
  Serial.println("IP address: "); Serial.println(WiFi.localIP());
   pinMode(LED_BUILTIN, OUTPUT);
 pinMode(flowsensor1, INPUT_PULLUP);

 pinMode(flowsensor2, INPUT_PULLUP);
attachInterrupt(0, flow, RISING); // Setup Interrupt
   sei(); // Enable interrupts
   //currentTime1 = millis();
   //cloopTime1 = currentTime1;
  // currentTime2 = millis();
  // cloopTime2 = currentTime2;
  price1 = 0.0;
  price2 = 0.0;
 
  
}
uint32_t x=0;
void loop(){
  MQTT_connect();
  
   currentTime1 = millis();
   // Every second, calculate and print litres/hour
   if(currentTime1 >= (cloopTime1 + 1000))
   {
      cloopTime1 = currentTime1; // Updates cloopTime
      // Pulse frequency (Hz) = 7.5Q, Q is flow rate in L/min.
      l_hour1 = (flow_frequency1 * 60 / 7.5);
      fR1=l_hour1/60;// (Pulse frequency x 60 min) / 7.5Q = flowrate in L/hour
      flow_frequency1 = 0; // Reset Counter
      Serial.print(l_hour1, DEC); // Print litres/hour
      Serial.println(" L/hour");
      Serial.print(fR1, DEC); // Print litres/hour
      Serial.println(" L/min");
   }
    totalLitres1 += fR1;
    price1 = totalLitres1*100.00;
    // Print the flow rate for this second in litres / minute
   
          // Print tab space


    // Print the cumulative total of litres flowed since starting
    Serial.print("\t"); 
    Serial.print("Output Liquid Quantity-1: ");
    Serial.print(totalLitres1);
    Serial.println("L");
    Serial.println("Price-1: ");
    Serial.print("Rs.");
    Serial.println(float(price1));  // Print the integer part of the variable
    
    





currentTime2 = millis();
   // Every second, calculate and print litres/hour
   if(currentTime2 >= (cloopTime2 + 1000))
   {
      cloopTime2 = currentTime2; // Updates cloopTime
      // Pulse frequency (Hz) = 7.5Q, Q is flow rate in L/min.
      l_hour2 = (flow_frequency2 * 60 / 7.5);
      fR2=l_hour2/60;// (Pulse frequency x 60 min) / 7.5Q = flowrate in L/hour
      flow_frequency2 = 0; // Reset Counter
      Serial.print(l_hour2, DEC); // Print litres/hour
      Serial.println(" L/hour");
      Serial.print(fR2, DEC); // Print litres/hour
      Serial.println(" L/min");
   }
    totalLitres2 += fR2;
    price2 = totalLitres2*100.00;
    // Print the flow rate for this second in litres / minute
   
          // Print tab space


    // Print the cumulative total of litres flowed since starting
    Serial.print("\t"); 
    Serial.print("Output Liquid Quantity-2: ");
    Serial.print(totalLitres2);
    Serial.println("L");
    Serial.println("Price-2: ");
    Serial.print("Rs.");
    Serial.println(float(price2));  // Print the integer part of the variable
    
    

 fr1.publish(fR1);
  v1.publish(totalLitres1);
  p1.publish(price1);
 fr2.publish(fR2);
  v2.publish(totalLitres2);
  p2.publish(price2);
  
  delay(10000);
}


void MQTT_connect() {
  int8_t ret;
  // Stop if already connected.
  if (mqtt.connected()) {
    return;
  }
  Serial.print("Connecting to MQTT... ");
  uint8_t retries = 3;
  while ((ret = mqtt.connect()) != 0) { // connect will return 0 for connected
       Serial.println(mqtt.connectErrorString(ret));
       Serial.println("Retrying MQTT connection in 5 seconds...");
       mqtt.disconnect();
       delay(5000);  // wait 5 seconds
       retries--;
       if (retries == 0) {
         // basically die and wait for WDT to reset me
         while (1);
       }
  }
  Serial.println("MQTT Connected!");
}
  
  
